/* ScrutariLib_SearchEngine - Copyright (c) 2014-2017 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.scrutari.searchengine.api.options;

import net.scrutari.db.api.codes.Codes;
import net.scrutari.db.api.codes.ElementCodes;
import net.scrutari.searchengine.api.operands.eligibility.Eligibility;


/**
 *
 * @author Vincent Calame
 */
public interface SearchOptions {

    /**
     * Cas particulier où la recherche doit porter sur un ensemble de fiches
     * précis getCorpusCodes() est censé être cohérent avec getFicheCodes (c'est
     * à dire ne contenir que les corpus qui ont des fiches dans getFicheCodes)
     * Null si non pertinent
     */
    public ElementCodes getFicheCodes();

    /**
     * Cette liste est une construction à partir des différentes options de la
     * recherche.
     */
    public Codes getCorpusCodes();

    /**
     * Cette liste est une construction à partir des différentes options de la
     * recherche.
     */
    public Codes getThesaurusCodes();

    public Eligibility getFicheEligibility();

    public SearchOptionsDef getSearchOptionsDef();

}
