/* UtilLib_Servlet - Copyright (c) 2010-2017 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.util.servlets;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import net.mapeadores.util.request.RequestMap;
import net.mapeadores.util.servlets.handlers.JsonResponseHandler;


/**
 *
 * @author Vincent Calame
 */
public class ServletUtils {

    private ServletUtils() {
    }

    public static String getContextPath(ServletContext servletContext) {
        String contextPath = servletContext.getContextPath();
        if (contextPath.length() == 0) {
            return "ROOT";
        } else {
            return contextPath.substring(1);
        }
    }

    public static void allowCredentials(JsonResponseHandler jsonResponseHandler, RequestMap requestMap) {
        Object sourceObject = requestMap.getSourceObject();
        if ((sourceObject != null) && (sourceObject instanceof HttpServletRequest)) {
            HttpServletRequest httpRequest = (HttpServletRequest) sourceObject;
            String origin = httpRequest.getHeader("origin");
            jsonResponseHandler.setAccessControl(origin);
        } else {
            jsonResponseHandler.setAccessControl(JsonResponseHandler.ALL_ORIGIN);
        }
        jsonResponseHandler.setAllowCredentials(true);
    }

    public static void allowCredentials(JsonResponseHandler jsonResponseHandler, HttpServletRequest httpRequest) {
        String origin = httpRequest.getHeader("origin");
        jsonResponseHandler.setAccessControl(origin);
        jsonResponseHandler.setAllowCredentials(true);
    }

}
